// camera.cpp
#include "global.h"

// ------------------------------------------------------------------------------------------------
CCamera::CCamera(void)
// ------------------------------------------------------------------------------------------------
{
	m_pCamera = NULL;
}

// ------------------------------------------------------------------------------------------------
CCamera::~CCamera(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
void CCamera::Loop(void)
// ------------------------------------------------------------------------------------------------
{
	m_pCamera->updateAbsolutePosition();
	m_pLight->updateAbsolutePosition();
}

// ------------------------------------------------------------------------------------------------
bool CCamera::Init(void)
// ------------------------------------------------------------------------------------------------
{
	if (!CreateCameraAndLight()) return(false);

	return(true);
}

// ------------------------------------------------------------------------------------------------
void CCamera::Exit(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
void CCamera::Reset(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
irr::scene::ICameraSceneNode* CCamera::GetCamera(void)
// ------------------------------------------------------------------------------------------------
{
	return(m_pCamera);
}

// ------------------------------------------------------------------------------------------------
irr::scene::ILightSceneNode*  CCamera::GetLight(void)
// ------------------------------------------------------------------------------------------------
{
	return(m_pLight);
}

// ------------------------------------------------------------------------------------------------
bool CCamera::CreateCameraAndLight(void)
// ------------------------------------------------------------------------------------------------
{
	extern GLOBALDATA gl_Data;
	
	m_pCamera = gl_Data.pSceneManager->addCameraSceneNodeMaya(gl_Data.pSceneManager->getRootSceneNode(),
															  -150.0f, // rotateSpeed 
															   100.0f, // zoomSpeed
															   150.0f, // translationSpeed  
															       0);	// id (normally -1)
 
	if (!m_pCamera) return(false);

	m_pCamera->setFOV(90.0f*PI/180.0f); // Overriding bad standard value (which is 45deg) with 90deg
	
 	m_pLight = gl_Data.pSceneManager->addLightSceneNode( m_pCamera,
														 irr::core::vector3df(0.0f, 1.0f, -1.0f),
														 irr::video::SColor(15,15,15,15),
														 (irr::s32) 3000);  // Radius

	SetToInitPosition();
	return(true);
}

// ------------------------------------------------------------------------------------------------
void CCamera::SetToInitPosition(void)
// ------------------------------------------------------------------------------------------------
{
	m_pCamera->setTarget(irr::core::vector3df(0.0f, 0.0f, 0.0f));
	m_pCamera->updateAbsolutePosition();
	
	m_pCamera->setPosition(irr::core::vector3df(0.0f, 30.0f, -100.0f));
}

