// gui.cpp
#include "global.h"

// ------------------------------------------------------------------------------------------------
CGui::CGui(void)
// ------------------------------------------------------------------------------------------------
{
	m_pHelpTextBox = NULL;
}

// ------------------------------------------------------------------------------------------------
CGui::~CGui(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
void CGui::Loop(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
bool CGui::Init(void)
// ------------------------------------------------------------------------------------------------
{
	extern GLOBALDATA gl_Data;

	// Load our own font
	m_pFont = gl_Data.pGUIEnv->getFont("./media/Arial_12.bmp");
	if (!m_pFont) return(false);
	gl_Data.pGUIEnv->getSkin()->setFont(m_pFont);

	// Changing alpha of windows etc. First, upper right color, then, lower left
	irr::video::SColor col = gl_Data.pGUIEnv->getSkin()->getColor(irr::gui::EGDC_3D_FACE);
	col.setAlpha(255);
	gl_Data.pGUIEnv->getSkin()->setColor(irr::gui::EGDC_3D_FACE, col);

	col = gl_Data.pGUIEnv->getSkin()->getColor(irr::gui::EGDC_3D_SHADOW );
	col.setAlpha(255);
	gl_Data.pGUIEnv->getSkin()->setColor(irr::gui::EGDC_3D_SHADOW , col);
	
	return(true);
}

// ------------------------------------------------------------------------------------------------
void CGui::Reset(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
void CGui::Exit(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
void CGui::ToggleF1Window(void)
// ------------------------------------------------------------------------------------------------
{
	extern GLOBALDATA gl_Data;

	irr::core::stringw sHelptext = L"";

	if (m_pHelpTextBox) // Deleting the object if it shall not be shown anymore
	{
		SAFEDELETE(m_pHelpTextBox);
	}
	else
    {
		irr::core::rect<irr::s32>  rDim( (irr::s32)(gl_Data.ScreenXY.Width  * 0.25f),
										 (irr::s32)(                          50   ),
										 (irr::s32)(gl_Data.ScreenXY.Width  * 0.75f),
										 (irr::s32)(gl_Data.ScreenXY.Height - 50   ));
		
		m_pHelpTextBox = new irr::gui::CGUIexScrollWindow(gl_Data.pGUIEnv, gl_Data.Gui.GetGuiFont(),rDim);		
		
		// Read in the help text file
		if (!gl_Data.pIrrlichtDevice->getFileSystem()->existFile("./media/helptext.txt")) sHelptext = L"Helpfile not found.";
		else 
		{
			irr::io::IReadFile *pFile;			
			pFile = gl_Data.pIrrlichtDevice->getFileSystem()->createAndOpenFile("./media/helptext.txt");
			
			irr::s32 iSize = pFile->getSize();
						
			char *dummy = new char[iSize+1];
			memset(dummy,0,iSize+1);
			pFile->read(dummy,iSize);

			for (irr::s32 i=0;i<(iSize+1);i++)
			{
				// Filtering /r, just leaving /n in place
				if (dummy[i] != '\r') sHelptext.append(dummy[i]);
			}
			
			delete[] dummy;
			pFile->drop();
		}

		m_pHelpTextBox->setText(sHelptext.c_str());
	}
}
// ------------------------------------------------------------------------------------------------
bool CGui::F1WindowActive(void)
// ------------------------------------------------------------------------------------------------
{
	if (m_pHelpTextBox) return(true);
	return(false);
}

// ------------------------------------------------------------------------------------------------
irr::gui::IGUIFont* CGui::GetGuiFont(void)
// ------------------------------------------------------------------------------------------------
{
	return(m_pFont);
}

