// input.cpp
#include "global.h"

// ------------------------------------------------------------------------------------------------
CInput::CInput(void)
// ------------------------------------------------------------------------------------------------
{
	memset(m_KeyState, 0, sizeof(m_KeyState));
}

// ------------------------------------------------------------------------------------------------
CInput::~CInput(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
void CInput::Loop(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
bool CInput::Init(void)
// ------------------------------------------------------------------------------------------------
{
	return(true);
}

// ------------------------------------------------------------------------------------------------
void CInput::Exit(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
void CInput::Reset(void)
// ------------------------------------------------------------------------------------------------
{
}

// ------------------------------------------------------------------------------------------------
bool CInput::OnEvent(irr::SEvent Event)
// ------------------------------------------------------------------------------------------------
{
	extern GLOBALDATA gl_Data; 

	if (Event.EventType == irr::EET_KEY_INPUT_EVENT) // a key is pressed or released 
	{ 
		// Help Box active. esc will close
		if (gl_Data.Gui.F1WindowActive() && Event.KeyInput.PressedDown) 
		{
			switch (Event.KeyInput.Key)
			{
			case irr::KEY_ESCAPE: gl_Data.Gui.ToggleF1Window(); return(true); // Esc closes window 
			default: break;
			} 
		}

		if ((Event.KeyInput.Key==irr::KEY_F1)&&(Event.KeyInput.PressedDown)) 
		{ 
			gl_Data.Gui.ToggleF1Window(); // Switch help window on or off
			return(true);
		}

		if ((Event.KeyInput.Key==irr::KEY_KEY_D)&&(Event.KeyInput.PressedDown)) 
		{ 
			gl_Data.Debug.ToggleDebugWindow(); // Switch debug window on or off
			return(true);
		}
		
		// Store key value (pressed/not pressed) to reminder array
		m_KeyState[Event.KeyInput.Key]    =  Event.KeyInput.PressedDown;

		return(false); // We did not process the incoming event
	}

	if (Event.EventType == irr::EET_GUI_EVENT)
	{			
		irr::s32 id = Event.GUIEvent.Caller->getID();
		if (Event.GUIEvent.EventType == irr::gui::EGET_BUTTON_CLICKED)
		{
			/*switch(id)
			{
				default: break;
			}*/
		}
	}

	return(false);
}
